program  X2dMute
  use sep
  use billgen
  !use waveprop2d
  !use base_fftwfl_mod
  !use dottest1
  implicit none
  integer                           ::ndim,nx,nt,nsx,itmute
  real                              ::ox,ot,osx,dx,dt,dsx,hmax,hmin
  real                              ::v0,t0,t0r,tramp,sx,x,t
  integer,dimension(:),allocatable  ::nsrc 
  real,dimension(:),allocatable     ::osrc,dsrc 
  real,dimension(:),allocatable     ::src, dat, vsurf, tfile 
  integer                           ::i,ix,ixsrc,it,isx,typ,istfile
  real                              ::pi,thresd,tmp

  call initpar()
  !call sep_init(SOURCE)
  
  !ndim=sep_dimension()
  ndim=3
 
  call from_param("nt",nt,400)
  call from_param("ot",ot,0.)
  call from_param("dt",dt,0.004)
  call from_param("nx",nx,100)
  call from_param("ox",ox,0.)
  call from_param("dx",dx,4.)
  call from_param("t0",t0,0.)
  call from_param("tramp",tramp,0.5)
  call from_param("v0",v0,1500.)
  call from_param("nsx",nsx,10)
  call from_param("osx",osx,0.)
  call from_param("dsx",dsx,16.)
  call from_param("istfile",istfile,0)
  call from_param("hmax",hmax,100000.)
  call from_param("hmin",hmin,500.)
  ! typ=1 means nmo mute time typ=2 means direct arrival mute time
  call from_param("type",typ,1)
  call from_param("thresd",thresd,0.1)

  


  allocate ( nsrc(ndim), osrc(ndim), dsrc(ndim) )
  
  nsrc(1)=nt
  nsrc(2)=nx
  nsrc(3)=nsx

  osrc(1)=ot
  osrc(2)=ox
  osrc(3)=osx

  dsrc(1)=dt
  dsrc(2)=dx
  dsrc(3)=dsx

  allocate ( src(product(nsrc)), dat(product(nsrc)), vsurf(nx), tfile(nsx))

  call sreed("vsurf",vsurf,nx*4)
  if (typ.eq.3) then 
     call sreed("in",dat,product(nsrc)*4)
  end if 
 write(0,*)"done read in dat"
  if (istfile==1) then
     call sreed("tfile",tfile, nsx*4)
  else
     tfile(1)=-0.123456789
  end if
  do it=1,product(nsrc)
     src(it)=1  
  end do
  
  pi=3.14159265
  call put_history(nsrc,osrc,dsrc,4)
  do isx=1,nsx
     !if (tfile(1)==0.123456789) then
        t0r=t0
     !else 
     !   t0r=tfile(isx) 
     !end if
     sx=osx+(isx-1)*dsx
     ixsrc=(sx-ox)/dx+1
     write(0,*)"ixsrc",isx
     do ix=1,nx
        if (abs((ix-1)*dx+ox-sx)>hmax) then
           do it=1,nt
              src( it+nt*(ix-1)+nt*nx*(isx-1) ) = 0;
           end do
        else if (abs((ix-1)*dx+ox-sx)<hmin) then
           do it=1,nt
              src( it+nt*(ix-1)+nt*nx*(isx-1) ) = 1;
           end do
        else
           if (typ.eq.1 ) then
              itmute=(sqrt(t0r**2+(abs((ix-1)*dx+ox-sx)/v0)**2)-ot)/dt+1;
           end if 
           if (typ.eq.2 ) then
              t=t0r
              if (ixsrc>ix) then
                 do i=ix,ixsrc
                    t=t+dx/vsurf(i);
                 end do
              else if (ixsrc<=ix) then
                 do i=ixsrc,ix
                    t=t+dx/vsurf(i);
                 end do
              end if
              itmute=(t-ot)/dt+1;
           end if
           if (typ.eq.3 ) then
              do it=1,nt
                 if (abs(dat( it+nt*(ix-1)+nt*nx*(isx-1) )) >thresd) then
                    itmute=it+35
                    exit;
                 end if
              end do
           end if 
           do it=1,int(max(itmute,1))
              src( it+nt*(ix-1)+nt*nx*(isx-1) ) = 0;
           end do
           do it=int(max(itmute,1))+1,int(min((itmute+(tramp/dt)),real(nt)))
              src( it+nt*(ix-1)+nt*nx*(isx-1) ) = src( it+nt*(ix-1)+nt*nx*(isx-1) )* abs((it-itmute)*dt/tramp )
           end do
        end if
     end do
  end do
  call srite("out",src,nt*nx*nsx*4)

 
end program X2dMute 

