program  X2dSh2Sg
  use sep
  use billgen
  !use waveprop2d
  !use base_fftwfl_mod
  !use dottest1
  implicit none
  integer                            ::ndim,nt,nx,ns,nh
  real                               ::ot,dt,t,ox,dx,x,os,ds,s,oh,dh,h
  integer,dimension(:),allocatable   ::nd 
  real,dimension(:),allocatable      ::od,dd 
  real,dimension(:,:,:),allocatable  ::dat, datout 
  integer                            ::it,ix,is,ih

  call initpar()
  !call sep_init(SOURCE)
  
  !ndim=sep_dimension()
  ndim=2
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
  !!!!!!!!!!read in  parameters
  call from_param("nx",nx,500)
  call from_param("dx",dx,50.)
  call from_param("ox",ox,-1000.)
  !call from_param("t0",t0,1.)

  
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
 !!!!! allocating all spaces and dimensional values for arrays and read data into these arrays
  allocate (nd(ndim+1),od(ndim+1),dd(ndim+1))
 
  !! read in data information
  call from_history("n1",nd(1))
  call from_history("n2",nd(2))
  call from_history("n3",nd(3))
  call from_history("o1",od(1))
  call from_history("o2",od(2))
  call from_history("o3",od(3))
  call from_history("d1",dd(1))
  call from_history("d2",dd(2))
  call from_history("d3",dd(3))

  nt=nd(1); ot=od(1); dt=dd(1)
  nh=nd(2); oh=od(2); dh=dd(2)
  ns=nd(3); os=od(3); ds=dd(3)
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
  
  allocate (datout(nt,nx,ns), dat(nt,nh,ns))
  
  call sreed("in",dat,product(nd)*4)

  do is=1,ns
     do ih=1,nh
        s = os+(is-1)*ds
        h = oh+(ih-1)*dh
        ix=(s+h-ox)/dx+1
        if ( (ix>0) .and. ix<(nx+1) ) then
           datout(:,ix,is)=dat(:,ih,is)
        end if
     end do 
  end do
       
  nd(2)=nx; od(2)=ox; dd(2)=dx
  call put_history(nd,od,dd,4)
  call srite("out",datout,product(nd)*4)
     
end program X2dSh2Sg 

