#include "stdlib.h"
#include "math.h"
#include "string.h"
#include <seplib.h>
#include <sep3dc.h>


#define Errmsg3(str,str1,str2)  {fprintf(stderr,str,str1,str2);return 1;}
int main(int argc, char** argv)
{
    int ndim,i,n;
    float o,d;
    char temp_char[256];
    int   nx, ny, nz;
    float ox, oy, oz;
    float dx, dy, dz;
    int   ix, iy, iz;
    int   needwvmv,jtmv;
    int   stat;
    float *vel,*zbtm;
    float waterV;
    sep3d outfile; 
    initpar(argc,argv);
    // read t,x,y from source file
   
    if(0!=sep_get_number_data_axes("in",&ndim))
       seperr("unable to get dimension from src!\n");
   
    ny=1; 
    for(i=1;i<=ndim;i++)
    {
       if(0!=sep_get_data_axis_par("in",&i,&n,&o,&d,temp_char))
       seperr("unable to get parameters from src!\n");
       if(i==1)
       {
          nz=n;
          dz=d;
          oz=o;
       }
       else if(i==2)
       {
          nx=n;
          dx=d;
          ox=o;
       }
       else if(i==3)
       {
          ny=n;
          dy=d;
          oy=o;
       }
    }

    // readin other parameters
    if (0==getch("waterV","f", &waterV)) waterV=1500;

    // allocate memories

    vel=(float*)malloc(nx*ny*nz*sizeof(float));
    zbtm=(float*)malloc(nx*ny*sizeof(float));

    srand(time(NULL));
    if (4*nx*ny*nz!=sreed("in",vel,4*nx*ny*nz))
	seperr("Error read in velocity from stdin");
    for (iy=0;iy<ny;iy++)
       for (ix=0;ix<nx;ix++)
          for (iz=0;iz<nz;iz++)
            if (fabsf(vel[iz+ix*nz+iy*nz*nx])>waterV)
            {
               zbtm[ix+iy*nx]=oz+iz*dz;
               break;
            }

    ndim=2;
    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=ox;
    outfile.d[0]=dx;
    outfile.n[0]=nx;
    outfile.o[1]=oy;
    outfile.d[1]=dy;
    outfile.n[1]=ny;
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("out",&outfile))
       seperr("unable to output parameters for out\n");

    if( (nx*ny*4)!=srite("out",zbtm,4*nx*ny) )
       seperr("trouble writing out zbtm\n");

    return 0;
}
