#define idep_type int


int XC2dCalgrad_ns, XC2dCalgrad_wvfieldsz, XC2dCalgrad_shotsz, XC2dCalgrad_rawgradsz;
int   XC2dCalgrad_nt,XC2dCalgrad_nx,XC2dCalgrad_nz;
float XC2dCalgrad_ot,XC2dCalgrad_ox,XC2dCalgrad_oz;
float XC2dCalgrad_dt,XC2dCalgrad_dx,XC2dCalgrad_dz;
int   XC2dCalgrad_nxtape,XC2dCalgrad_nztape;
int   XC2dCalgrad_jtmv;
int   XC2dCalgrad_objtype;
int   XC2dCalgrad_rndbnd_type;
float XC2dCalgrad_thresd;

idep_type *XC2dCalgrad_isdep, *XC2dCalgrad_irdep;
float *XC2dCalgrad_1shotdcal;
float *XC2dCalgrad_1shotsrcfield;
float *XC2dCalgrad_1shotrcvfield;

int XC2dCalgrad_init( int ntin,  int nxin,  int nzin, int nsin,  \
                      float otin,float oxin,float ozin,          \
                      float dtin,float dxin,float dzin,          \
                      int nxtapein, int nztapein,             \
                      int *isdepin, int *irdepin,                           \
                      int jtmvin, long *memcnt, int objtypein, float thresdin, int rndbnd_type );


int XC2dCalgrad_rawgrad(float *dxinvvelinvdt2 , float *dxinvvelinvdt2_rndbnd, float *dobs, float *dwht, float *dcal, float *dres, float *fval, float *vsrc, float *src, double *grad, int grad_sz, double *precond, int needprecond, int nxspline, int nzspline, int dxspline, int dzspline, double *sprecond, char *rdfulpath, int inode, int isgradupdown, int isgradleftright, int rcdmv, char* mvpath );
int XC2dCalgrad_splineprecond(int nzspline ,int nxspline, float dzspline, float dxspline, double *sprecond );
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////


int XC2dCalgrad_init( int ntin,  int nxin,  int nzin, int nsin,  \
                      float otin,float oxin,float ozin,          \
                      float dtin,float dxin,float dzin,          \
                      int nxtapein, int nztapein,             \
                      int *isdepin, int *irdepin,                           \
                      int jtmvin, long *memcnt, int objtypein, float thresdin, int rndbnd_type )
{
    int is;
    float vmax; 

    XC2dCalgrad_nt=ntin;
    XC2dCalgrad_nx=nxin;
    XC2dCalgrad_nz=nzin;

    XC2dCalgrad_ot=otin;
    XC2dCalgrad_ox=oxin;
    XC2dCalgrad_oz=ozin;

    XC2dCalgrad_dt=dtin;
    XC2dCalgrad_dx=dxin;
    XC2dCalgrad_dz=dzin;

    XC2dCalgrad_nxtape=nxtapein;
    XC2dCalgrad_nztape=nztapein;

    XC2dCalgrad_jtmv=jtmvin;
    XC2dCalgrad_objtype=objtypein;
    XC2dCalgrad_thresd=thresdin;
    XC2dCalgrad_rndbnd_type=rndbnd_type;

    fprintf(stderr,"thresd=%e,objtype=%d, rndbnd_type=%d\n",thresdin, objtypein,rndbnd_type);   

    if (nxin<=2*nxtapein)
       WpErrmsg("Error, nx less or equal than twice of padded x reigon\n")
    if (nzin<=2*nztapein)
       WpErrmsg("Error, nz less or equal than twice of padded z reigon\n")

    // determine if dx==dy==dz
    if (  dzin!=dxin )
       WpErrmsg("ERROR in Calgrad_init , dz not equal to dx, exit!!!\n")
    else
    {
       // produce (vel*dt/dx)**2 and get vmax/izmax_inc on the way
       XC2dCalgrad_ns=nsin;
       XC2dCalgrad_rawgradsz=nxin*nzin;
       XC2dCalgrad_wvfieldsz=(nxin-2*nxtapein)*(nzin-2*nztapein)*(ntin/jtmvin+2);
       XC2dCalgrad_shotsz=(nxin-2*nxtapein)*ntin;
       if (rndbnd_type==0) 
       {
          XC2dCalgrad_1shotsrcfield=(float*)malloc(XC2dCalgrad_wvfieldsz*sizeof(float));
          XC2dCalgrad_1shotrcvfield=(float*)malloc(XC2dCalgrad_wvfieldsz*sizeof(float));
          memcnt+=XC2dCalgrad_wvfieldsz*sizeof(float)*2;
       }
       //XC2dCalgrad_1shotdcal=(float*)malloc(XC2dCalgrad_shotsz*sizeof(float));
       XC2dCalgrad_isdep=isdepin;
       XC2dCalgrad_irdep=irdepin;
    }

    // needwvmvin equals 2 means the waveprop operator is for waveform inversion, then recorded data/wvmv/isdep/irdep is without tapering zone
    //int needwvmvin=2.;
    // initilize wave propagation module
    //stat=XC2dWaveprop_Init(ntin,nxin,nyin,nzin,nxtapein,nytapein,nztapein,needwvmvin,jtmvin);
    //if (stat==1)
    //   Errmsg("Error in XC2dWaveprop_Init, program terminated!\n")

    return 0;
}

int XC2dCalgrad_rawgrad(float *dxinvvelinvdt2 , float *dxinvvelinvdt2_rndbnd, float *dobs, float *dwht, float *dcal, float *dres, float *fval, float *vsrc, float *src, double *grad, int grad_sz, double *precond, int needprecond, int nxspline, int nzspline, int dxspline, int dzspline, double *sprecond, char *rdfulpath, int inode, int isgradupdown, int isgradleftright, int rcdmv, char* mvpath )
{
   int is,i,it,ix,iz,idx;
   int ns,sz;
   int tsign,stat;
   int *isdep, *irdep;
   float *shotsrc;
   float maxv,maxval,temp1,temp2,tmp;
   int izmax_inc;
   int needvsrc,needdat;
   int fat=2;
   double tmpfval; 
   float sum=0;
   int cnt,cnt1; 
   float pi;
   int needwvmv;
   ns = XC2dCalgrad_ns;  
   if (grad_sz!=XC2dCalgrad_rawgradsz)
       WpErrmsg("ERROR in Calgrad_rawgrad,  grad_sz not equal to XC2dCalgrad_rawgrad_sz, exit!!!\n")
 
   pi=3.14159265;
   VerbMsg("start zero grad in rawgrad \n")
   for (i=0;i<grad_sz;i++)
      grad[i]=0.;

   if (needprecond==1)
      for (i=0;i<grad_sz;i++)
         precond[i]=0.;
   else if (needprecond>1)
      fprintf(stderr,"Warning! needprecond>1 is not implemented in this version, using needprecond==1 instead!\n");

   maxv=10000.;
   VerbMsg("start maxv calculation in rawgrad \n")
   for (i=0;i<XC2dCalgrad_nz*XC2dCalgrad_nx;i++)
      if (dxinvvelinvdt2[i]<maxv)
         maxv=dxinvvelinvdt2[i]; 
   
   izmax_inc=sqrtf(1./maxv)+2;
   tmpfval=0.;
   //VerbMsg2("#############start looping over shots in rawgrad with ns=%d %d\n",ns,ns)
   cnt=0; 
   cnt1=0;
    
   for (is=0;is<ns;is++)  
   {
      if (XC2dCalgrad_rndbnd_type==0)
      {
         sz=(XC2dCalgrad_nz-2*XC2dCalgrad_nztape)*(XC2dCalgrad_nx-2*XC2dCalgrad_nxtape)*(XC2dCalgrad_nt/(XC2dCalgrad_jtmv));
         for (i=0;i<sz;i++)
 	 {    
            XC2dCalgrad_1shotsrcfield[i]=0; 
            XC2dCalgrad_1shotrcvfield[i]=0; 
         }
      }
      tsign=1;
      isdep=&XC2dCalgrad_isdep[is*(XC2dCalgrad_nx-2*XC2dCalgrad_nxtape)];
      irdep=&XC2dCalgrad_irdep[is*(XC2dCalgrad_nx-2*XC2dCalgrad_nxtape)];
      shotsrc=&src[is*XC2dCalgrad_shotsz];

      VerbMsg("-----start forward propagation in rawgrad \n")
      if (XC2dCalgrad_rndbnd_type==0)
      {
         needwvmv=1;
	 stat=XC2dWaveprop_setwvmv(needwvmv);
      }
      stat=XC2dWaveprop_op2( tsign, isdep, irdep, shotsrc, dxinvvelinvdt2, izmax_inc, dcal, XC2dCalgrad_1shotsrcfield );
      if (XC2dCalgrad_rndbnd_type==0)
      {
         needwvmv=0;
	 stat=XC2dWaveprop_setwvmv(needwvmv);
      }
      sum=0; 
      for (i=0;i<sz;i++)
          sum+=fabsf(dcal[i]);
      fprintf(stderr,"sum of abs dcal is %f in node %d \n",sum,inode);
      if (stat==1)
         WpErrmsg("Error calling XC2dWaveprop_op2 in XC2dCalgrad_rawgrad, program terminated!\n")
      /*
      sum=0;
       for (i=0;i<XC2dCalgrad_wvfieldsz;i++)
          sum+=fabsf(XC2dCalgrad_1shotsrcfield[i]);
       VerbMsg2("src wavefield sum of size %d is %f \n",XC2dCalgrad_wvfieldsz,sum)
       */ 

      //sz=XC2dCalgrad_nt*(XC2dCalgrad_nx-2*XC2dCalgrad_nxtape);
      //if( (sz*4)!=srite(rdfulpath,dcal,4*sz) )
      //    seperr("trouble writing out data residual\n");
      stat=XC2dWI_whtdat(dcal, dcal, &dwht[is*XC2dCalgrad_shotsz], XC2dCalgrad_shotsz);
      if (stat==1)
         WpErrmsg("Error calling XC2dWI_whtdat in XC2dCalgrad_rawgrad, program terminated!\n")
     
      needvsrc=1;
      VerbMsg("-----start calresd in rawgrad \n")
      if (XC2dCalgrad_objtype==0)
      {
         stat=XC2dWI_calresd_conv(&dobs[is*XC2dCalgrad_shotsz], dcal, dres, vsrc, needvsrc, XC2dCalgrad_nt, XC2dCalgrad_shotsz/XC2dCalgrad_nt);
         if (stat==1)
            WpErrmsg("Error calling XC2dWI_calresd_conv in XC2dCalgrad_rawgrad, program terminated!\n")
      }
      else if (XC2dCalgrad_objtype==1)
      {
         stat=XC2dWI_calresd_WT(&dobs[is*XC2dCalgrad_shotsz], dcal, dres, vsrc, needvsrc, XC2dCalgrad_nt, XC2dCalgrad_shotsz/XC2dCalgrad_nt, XC2dCalgrad_thresd);
         if (stat==1)
            WpErrmsg("Error calling XC2dWI_calresd_WT in XC2dCalgrad_rawgrad, program terminated!\n")
      }
      else if (XC2dCalgrad_objtype==2)
      {
         stat=XC2dWI_calresd_NormAmp(&dobs[is*XC2dCalgrad_shotsz], dcal, dres, vsrc, needvsrc, XC2dCalgrad_nt, XC2dCalgrad_shotsz/XC2dCalgrad_nt, XC2dCalgrad_thresd);
         if (stat==1)
            WpErrmsg("Error calling XC2dWI_calresd_NormAmp in XC2dCalgrad_rawgrad, program terminated!\n")
      }
       
      sz=XC2dCalgrad_nt*(XC2dCalgrad_nx-2*XC2dCalgrad_nxtape);
      if( (sz*4)!=srite(rdfulpath,dres,4*sz) )
          seperr("trouble writing out data residual\n");

      if( (sz*4)!=srite(rdfulpath,vsrc,4*sz) )
          seperr("trouble writing out virtue src\n");
      /*
      if( (sz*4)!=srite(rdfulpath,dcal,4*sz) )
          seperr("trouble writing out data residual\n");

      if( (sz*4)!=srite(rdfulpath,&dobs[is*XC2dCalgrad_shotsz],4*sz) )
          seperr("trouble writing out virtue src\n");
      */
      sum=0; 
      for (i=0;i<sz;i++)
          sum+=fabsf(dres[i]);
      fprintf(stderr,"sum of abs dres is %f in node %d \n",sum,inode);
      sum=0; 
      for (i=0;i<sz;i++)
          sum+=fabsf(dobs[i+is*XC2dCalgrad_shotsz]);
      fprintf(stderr,"sum of abs dobs is %f in node %d \n",sum,inode);
      VerbMsg("-----start calobjfunc in rawgrad \n")
      if (is==0)
         stat=XC2dWI_calobjfunc(&dwht[is*XC2dCalgrad_shotsz], dres, XC2dCalgrad_nt, XC2dCalgrad_shotsz/XC2dCalgrad_nt, &tmpfval);
      if (stat==1)
         WpErrmsg("Error calling XC2dWI_calobjfunc in XC2dCalgrad_rawgrad, program terminated!\n")
      VerbMsg("-----start gradient calculation \n")
      if (XC2dCalgrad_rndbnd_type>0)
      {
         stat=XC2dWaveprop_op2_rndbnd_withimag(isdep,irdep, shotsrc, dxinvvelinvdt2_rndbnd, izmax_inc, vsrc, grad, precond, needprecond, (XC2dCalgrad_dt*XC2dCalgrad_jtmv), isgradupdown, isgradleftright, inode, rcdmv, mvpath );
         if (stat==1)
            WpErrmsg("Error calling XC2dWaveprop_op2_rndbnd_withimag in XC2dCalgrad_rawgrad, program terminated!\n")
      }
      else
      {
         needwvmv=1;
	 stat=XC2dWaveprop_setwvmv(needwvmv);
         tsign=-1;
         isdep=&XC2dCalgrad_irdep[is*(XC2dCalgrad_nx-2*XC2dCalgrad_nxtape)];
         irdep=&XC2dCalgrad_irdep[is*(XC2dCalgrad_nx-2*XC2dCalgrad_nxtape)];
         shotsrc=&vsrc[0];
         needdat=0;
         stat=XC2dWaveprop_setrcddat(needdat);

         VerbMsg("-----start backward propagation in rawgrad \n")
         stat=XC2dWaveprop_op2( tsign, isdep, irdep, shotsrc, dxinvvelinvdt2, izmax_inc, dcal, XC2dCalgrad_1shotrcvfield );
         needdat=1;
         stat=XC2dWaveprop_setrcddat(needdat);
         sz=(XC2dCalgrad_nz-2*XC2dCalgrad_nztape)*(XC2dCalgrad_nx-2*XC2dCalgrad_nxtape);
         for (i=0;i<sz;i++)
            for (it=0+fat;it<XC2dCalgrad_nt/XC2dCalgrad_jtmv-fat;it++)
            {
               temp1=( -1./12.*XC2dCalgrad_1shotsrcfield[i+(it-2)*sz] \
                       +4./3. *XC2dCalgrad_1shotsrcfield[i+(it-1)*sz] \
                       -2.5   *XC2dCalgrad_1shotsrcfield[i+(it  )*sz] \
                       +4./3. *XC2dCalgrad_1shotsrcfield[i+(it+1)*sz] \
                       -1./12.*XC2dCalgrad_1shotsrcfield[i+(it+2)*sz]) /(XC2dCalgrad_dt*XC2dCalgrad_jtmv)/(XC2dCalgrad_dt*XC2dCalgrad_jtmv);
               temp2 = XC2dCalgrad_1shotrcvfield[i+it*sz];
               //if (it<XC2dCalgrad_nt/(15*XC2dCalgrad_jtmv))
               //{
               //   temp1*=0.5*(1.-cos(pi*it*(15*XC2dCalgrad_jtmv)/XC2dCalgrad_nt));
               //   temp2*=0.5*(1.-cos(pi*it*(15*XC2dCalgrad_jtmv)/XC2dCalgrad_nt));
               //}
               ix=i/(XC2dCalgrad_nz-2*XC2dCalgrad_nztape);
               iz=i-ix*(XC2dCalgrad_nz-2*XC2dCalgrad_nztape);
               idx=(iz+XC2dCalgrad_nztape) +(ix+XC2dCalgrad_nxtape)*XC2dCalgrad_nz;
               grad[idx]+=-temp1*temp2;
               if (needprecond>0)
                  precond[idx]+=temp1*temp1;
            }
         needwvmv=0;
	 stat=XC2dWaveprop_setwvmv(needwvmv);

         
      }
   } 

   *fval=tmpfval;
 
   return 0;
}

int XC2dCalgrad_splineprecond(int nzspline ,int nxspline, float dzspline, float dxspline, double *sprecond )
{
  int   nz,nx,ny,nt;
  float dz,dx;
  int n3, idim, sz, fat;
  int it,ix,iz,i,idx;
  int stat;

  nz=XC2dCalgrad_nz;
  nx=XC2dCalgrad_nx;
  nt=XC2dCalgrad_nt;
  ny=1;
  dz=XC2dCalgrad_dz;
  dx=XC2dCalgrad_dx;

  float *splineinarray, *splinetmparray1, *splinetmparray2, *srcarray;

  VerbMsg1("!!!!!!!!!!!!!!!!!!! in splineprecond nx=%d \n",nx)
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in splineprecond nz=%d \n",nz)
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in splineprecond nxspline=%d \n",nxspline)
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in splineprecond nzspline=%d \n",nzspline)
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in splineprecond dxspline=%f \n",dxspline)
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in splineprecond dzspline=%f \n",dzspline)
  splineinarray=(float*)malloc(sizeof(float)*nz*nx);
  splinetmparray1=(float*)malloc(sizeof(float)*nzspline*nx);
  splinetmparray2=(float*)malloc(sizeof(float)*nzspline*nxspline);
  srcarray=(float*)malloc(sizeof(float)*nzspline*nxspline);

  fat=2;
  for (it=0+fat;it<XC2dCalgrad_nt/XC2dCalgrad_jtmv-fat;it++)
  {
     n3=1;
     sz=(nx-2*XC2dCalgrad_nxtape)*(nz-2*XC2dCalgrad_nztape);
     //first take care of source side
     for (i=0;i<sz;i++)
     {
        ix=i/(XC2dCalgrad_nz-2*XC2dCalgrad_nztape);
        iz=i-ix*(XC2dCalgrad_nz-2*XC2dCalgrad_nztape);
        idx=(iz+XC2dCalgrad_nztape) +(ix+XC2dCalgrad_nxtape)*XC2dCalgrad_nz;
        splineinarray[idx]=( -1./12.*XC2dCalgrad_1shotsrcfield[i+(it-2)*sz] \
                           +4./3. *XC2dCalgrad_1shotsrcfield[i+(it-1)*sz] \
                           -2.5   *XC2dCalgrad_1shotsrcfield[i+(it  )*sz] \
                           +4./3. *XC2dCalgrad_1shotsrcfield[i+(it+1)*sz] \
                          -1./12.*XC2dCalgrad_1shotsrcfield[i+(it+2)*sz]) /(XC2dCalgrad_dt*XC2dCalgrad_jtmv)/(XC2dCalgrad_dt*XC2dCalgrad_jtmv);
     }
     stat=XC2dWI_padfgrad(splineinarray, splineinarray, nx, nz, XC2dCalgrad_nxtape, XC2dCalgrad_nztape );
     if (stat==1)
        WpErrmsg("Error calling XC2dWI_padfgrad in XC2dCalgrad_splineprecond for source side, program teminated!\n");
     sz=nx*ny*nzspline;
     for (i=0;i<sz;i++)
        splinetmparray1[i]=0;
     sz=nxspline*nzspline*ny;
     for (i=0;i<sz;i++)
        splinetmparray2[i]=0;
     sz=nxspline*nzspline;
     for (i=0;i<sz;i++)
        srcarray[i]=0;
     idim=0;
     stat=XC2dWI_spline_fadj(splinetmparray1, splineinarray, nzspline, nx, ny, idim, dzspline, nz, dz);
     if (stat==1)
        WpErrmsg("Error calling XC2dWI_spline_adj in XC2dCalgrad_splineprecond for source side, program teminated!\n");
     idim=1;
     stat=XC2dWI_spline_fadj(srcarray, splinetmparray1, nzspline, nxspline, ny, idim, dxspline, nx, dx);
     if (stat==1)
        WpErrmsg("Error calling XC2dWI_spline_adj in XC2dCalgrad_splineprecond for source side, program teminated!\n");

     sz=nxspline*nzspline;
     for (i=0;i<sz;i++)
        sprecond[i]+=srcarray[i]*srcarray[i];
  }
  free(splineinarray);
  free(splinetmparray1);
  free(splinetmparray2);
  free(srcarray);

  return 0;
}
