#include "stdlib.h"
#include "math.h"
#include "string.h"
#include <seplib.h>
#include <sep3dc.h>


#define Errmsg3(str,str1,str2)  {fprintf(stderr,str,str1,str2);return 1;}
int main(int argc, char** argv)
{
    int ndim,i,n;
    float o,d;
    char temp_char[256];
    int   nx, ny, nz;
    float ox, oy, oz;
    float dx, dy, dz;
    int   ix, iy, iz,iz1;
    int   needwvmv,jtmv;
    int   stat;
    float *vel,*cbtm,*v1d;
    float waterV;
    sep3d outfile; 
    initpar(argc,argv);
    // read t,x,y from source file
   
    if(0!=sep_get_number_data_axes("in",&ndim))
       seperr("unable to get dimension from src!\n");
    
    for(i=1;i<=ndim;i++)
    {
       if(0!=sep_get_data_axis_par("in",&i,&n,&o,&d,temp_char))
       seperr("unable to get parameters from src!\n");
       if(i==1)
       {
          nz=n;
          dz=d;
          oz=o;
       }
       else if(i==2)
       {
          nx=n;
          dx=d;
          ox=o;
       }
       else if(i==3)
       {
          ny=n;
          dy=d;
          oy=o;
       }
    }
    ny=1;dy=dx;oy=0;

    // readin other parameters
    if (0==getch("waterV","f", &waterV)) waterV=1500;

    // allocate memories

    vel=(float*)malloc(nx*ny*nz*sizeof(float));
    cbtm=(float*)malloc(nx*ny*sizeof(float));
    v1d=(float*)malloc(nz*sizeof(float));
    if (waterV==0.)
       if (nx*nz*4!=sreed("in",vel,nx*nz*4))
          seperr("Error readin vel from in!\n");
    if (nx*ny*4!=sreed("cbtm",cbtm,nx*ny*4))
       seperr("Error readin cbtm from cbtm!\n");
    if (nz*4!=sreed("v1d",v1d,nz*4))
       seperr("Error readin v1d from v1d!\n");

    for (iy=0;iy<ny;iy++)
       for (ix=0;ix<nx;ix++)
       {
          iz1=(cbtm[ix+iy*nx]-oz)/dz;
	  if (iz1<0)
             iz1=0;
	  if (iz1>=nz)
             iz1=nz-1;
          if (waterV!=0.)
             for (iz=0;iz<iz1;iz++)
                vel[iz+ix*nz+iy*nz*nx]=waterV;
          for (iz=iz1;iz<nz;iz++)
             vel[iz+ix*nz+iy*nz*nx]=v1d[iz-iz1];
       }
    ndim=3;
    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=oz;
    outfile.d[0]=dz;
    outfile.n[0]=nz;
    outfile.o[1]=ox;
    outfile.d[1]=dx;
    outfile.n[1]=nx;
    outfile.o[2]=oy;
    outfile.d[2]=dy;
    outfile.n[2]=ny;
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("vel",&outfile))
       seperr("unable to output parameters for vel\n");

    if( (nz*nx*ny*4)!=srite("vel",vel,4*nz*nx*ny) )
       seperr("trouble writing out vel\n");

    return 0;
}
