#include "stdlib.h"
#include "math.h"
#include "time.h"
#include "string.h"
#include <seplib.h>
#include <sep3dc.h>
#include "warp.c"


void generr1(int nl, int ni, int nx, int w, float *dat, float *dat1, float *e);
void generr(int nl, int ni, int w, float *dat, float *dat1, float *e);
#define Errmsg3(str,str1,str2)  {fprintf(stderr,str,str1,str2);return 1;}
int main(int argc, char** argv)
{
    int ndim,i,n;
    float o,d;
    char temp_char[256];
    int   nx, nt, ntlag;
    float ox, ot;
    float dx, dt;
    int   ix, it, il;
    int   needwvmv,jtmv,bds;
    int   stat,width,hbt,b,idx1;
    float *datin, *datout, *tlag;
    time_t time1,time2,terr,tbds,tac,tbt;
    sep3d outfile; 
    initpar(argc,argv);
    // read t,x,y from source file
   
    if(0!=sep_get_number_data_axes("in",&ndim))
       seperr("unable to get dimension from src!\n");
   
    for(i=1;i<=ndim;i++)
    {
       if(0!=sep_get_data_axis_par("in",&i,&n,&o,&d,temp_char))
       seperr("unable to get parameters from src!\n");
       if(i==1)
       {
          nt=n;
          dt=d;
          ot=o;
       }
       else if(i==2)
       {
          nx=n;
          dx=d;
          ox=o;
       }
    }

    // allocate memories

    datin=(float*)malloc(nx*nt*sizeof(float));
    datout=(float*)malloc(nx*nt*sizeof(float));
    tlag=(float*)malloc(nx*nt*sizeof(float));

    if (4*nx*nt!=sreed("in",datin,4*nx*nt))
	seperr("Error read in dat from stdin");

    if (4*nx*nt!=sreed("tlag",tlag,4*nx*nt))
	seperr("Error read in dat from stdin");

    for (ix=0;ix<nx;ix++)
       for (it=0;it<nt;it++)
         datout[it+ix*nt]=0;
    for (i=0;i<nx*nt;i++)
    {
       idx1=i+tlag[i];
       datout[idx1]=datin[i];
    }
    ndim=2;
    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=ot;
    outfile.d[0]=dt;
    outfile.n[0]=nt;
    outfile.o[1]=ox;
    outfile.d[1]=dx;
    outfile.n[1]=nx;
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("out",&outfile))
       seperr("unable to output parameters for out\n");

    if( (nx*nt*4)!=srite("out",datout,4*nx*nt) )
       seperr("trouble writing out datout\n");
    
    return 0;
}
