#include "stdlib.h"
#include "math.h"
#include "time.h"
#include "string.h"
#include <seplib.h>
#include <sep3dc.h>
#include "warp.c"


void generr1(int nl, int ni, int nx, int w, float *dat, float *dat1, float *e);
void generr(int nl, int ni, int w, float *dat, float *dat1, float *e);
#define Errmsg3(str,str1,str2)  {fprintf(stderr,str,str1,str2);return 1;}
int main(int argc, char** argv)
{
    int ndim,i,n;
    float o,d;
    char temp_char[256];
    int   nx, nt, ntlag;
    float ox, ot;
    float dx, dt;
    int   ix, it, il;
    int   needwvmv,jtmv,bds;
    int   stat,width,hbt,b;
    float *datin, *err, *errf, *errr, *errc, *u, *ut, *errs, *datin1;
    time_t time1,time2,terr,tbds,tac,tbt;
    sep3d outfile; 
    initpar(argc,argv);
    // read t,x,y from source file
   
    if(0!=sep_get_number_data_axes("in",&ndim))
       seperr("unable to get dimension from src!\n");
   
    for(i=1;i<=ndim;i++)
    {
       if(0!=sep_get_data_axis_par("in",&i,&n,&o,&d,temp_char))
       seperr("unable to get parameters from src!\n");
       if(i==1)
       {
          nt=n;
          dt=d;
          ot=o;
       }
       else if(i==2)
       {
          nx=n;
          dx=d;
          ox=o;
       }
    }

    // readin other parameters
    if (0==getch("ntlag","i", &ntlag)) ntlag=100;
    if (0==getch("width","i", &width)) width=20;
    if (0==getch("bds","i", &bds)) bds=0;
    if (0==getch("b","i", &b)) b=4;
    if (0==getch("hbt","i", &hbt)) hbt=0;

    // allocate memories

    datin=(float*)malloc(nx*nt*sizeof(float));
    datin1=(float*)malloc(nx*nt*sizeof(float));
    err=(float*)malloc(nx*nt*(2*ntlag+1)*sizeof(float));
    errf=(float*)malloc(nx*nt*(2*ntlag+1)*sizeof(float));
    errr=(float*)malloc(nx*nt*(2*ntlag+1)*sizeof(float));
    errs=(float*)malloc(nx*nt*(2*ntlag+1)*sizeof(float));
    errc=(float*)malloc(nx*nt*(2*ntlag+1)*sizeof(float));
    u=(float*)malloc(nx*nt*sizeof(float));
    ut=(float*)malloc(nx*nt*sizeof(float));

    if (4*nx*nt!=sreed("in",datin,4*nx*nt))
	seperr("Error read in dat from stdin");

    if (4*nx*nt!=sreed("dat1",datin1,4*nx*nt))
	seperr("Error read in dat from stdin");

    fprintf(stderr,"nt=%d,ntlag=%d,width=%d\n",nt,ntlag,width);
    int nl=2*ntlag+1;
    // generate errors
    time1=time(NULL);
    //generr1(nl,nt,nx,width, datin1,datin,err);
    for (ix=0;ix<nx;ix++)
       generr(nl,nt,width, &datin1[ix*nt], &datin[ix*nt], &err[ix*nt*nl]);
    time2=time(NULL);
    terr=time2-time1;
    fprintf (stderr,"generating errors done!\n");
    if (bds==1)
    {
       time1=time(NULL);
       fprintf(stderr,"bi-directional smoothing is on!\n");
       for (ix=0;ix<nx;ix++)
          bdsmooth(nl, nt, &err[ix*nt*nl], &err[ix*nt*nl], &errf[ix*nt*nl], &errr[ix*nt*nl]);
       fprintf (stderr,"bi-directional smoothing done!\n");
       time2=time(NULL);
       tbds=time2-time1;
    }
    if (bds==2)
    {
       for (i=0;i<nx*nt*nl;i++)
       {
          errf[i]=0;
          errr[i]=0;
       }
       time1=time(NULL);
       fprintf(stderr,"bi-directional smoothing is on!\n");
       for (ix=0;ix<nx;ix++)
          bdsmooth(nl, nt, &err[ix*nt*nl], &err[ix*nt*nl], &errf[ix*nt*nl], &errr[ix*nt*nl]);
       for (ix=0;ix<nx;ix++)
          for (it=0;it<nt;it++)
             for (il=0;il<nl;il++)
                errc[il+ix*nl+it*nx*nl]=err[il+it*nl+ix*nt*nl];    
       for (i=0;i<nx*nt*nl;i++)
       {
          errf[i]=0;
          errr[i]=0;
       }
       for (it=0;it<nt;it++)
          bdsmooth(nl, nx, &errc[it*nx*nl], &errc[it*nx*nl], &errf[it*nx*nl], &errr[it*nx*nl]);
       for (ix=0;ix<nx;ix++)
          for (it=0;it<nt;it++)
             for (il=0;il<nl;il++)
                err[il+it*nl+ix*nt*nl]=errc[il+ix*nl+it*nx*nl];    
       fprintf (stderr,"bi-directional smoothing done!\n");
       time2=time(NULL);
       tbds=time2-time1;
    }
    if (bds==3)
    {
       time1=time(NULL);
       fprintf(stderr,"bi-directional smoothing is on!\n");
       for (ix=0;ix<nx;ix++)
          bdsmooth(nl, nt, &err[ix*nt*nl], &err[ix*nt*nl], &errf[ix*nt*nl], &errr[ix*nt*nl]);
       for (ix=0;ix<nx;ix++)
          for (it=0;it<nt;it++)
             for (il=0;il<nl;il++)
                errc[il+ix*nl+it*nx*nl]=err[il+it*nl+ix*nt*nl];    
       for (it=0;it<nt;it++)
          bdsmooth(nl, nx, &errc[it*nx*nl], &errc[it*nx*nl], &errf[it*nx*nl], &errr[it*nx*nl]);
       for (ix=0;ix<nx;ix++)
          for (it=0;it<nt;it++)
             for (il=0;il<nl;il++)
                err[il+it*nl+ix*nt*nl]=errc[il+ix*nl+it*nx*nl];    
       for (i=0;i<nx*nt*nl;i++)
       {
          errf[i]=0;
          errr[i]=0;
       }
       for (ix=0;ix<nx;ix++)
          bdsmooth(nl, nt, &err[ix*nt*nl], &err[ix*nt*nl], &errf[ix*nt*nl], &errr[ix*nt*nl]);
       fprintf (stderr,"bi-directional smoothing done!\n");
       time2=time(NULL);
       tbds=time2-time1;
    }
    if (bds==4)
    {
       time1=time(NULL);
       fprintf(stderr,"bi-directional smoothing is on!\n");
       for (ix=0;ix<nx;ix++)
          bdsmooth(nl, nt, &err[ix*nt*nl], &err[ix*nt*nl], &errf[ix*nt*nl], &errr[ix*nt*nl]);
       for (ix=0;ix<nx;ix++)
          for (it=0;it<nt;it++)
             for (il=0;il<nl;il++)
                errc[il+ix*nl+it*nx*nl]=err[il+it*nl+ix*nt*nl];    
       for (it=0;it<nt;it++)
          bdsmooth(nl, nx, &errc[it*nx*nl], &errc[it*nx*nl], &errf[it*nx*nl], &errr[it*nx*nl]);
       for (ix=0;ix<nx;ix++)
          for (it=0;it<nt;it++)
             for (il=0;il<nl;il++)
                err[il+it*nl+ix*nt*nl]=errc[il+ix*nl+it*nx*nl];    
       for (ix=0;ix<nx;ix++)
          bdsmooth(nl, nt, &err[ix*nt*nl], &err[ix*nt*nl], &errf[ix*nt*nl], &errr[ix*nt*nl]);
       for (ix=0;ix<nx;ix++)
          for (it=0;it<nt;it++)
             for (il=0;il<nl;il++)
                errc[il+ix*nl+it*nx*nl]=err[il+it*nl+ix*nt*nl];    
       for (it=0;it<nt;it++)
          bdsmooth(nl, nx, &errc[it*nx*nl], &errc[it*nx*nl], &errf[it*nx*nl], &errr[it*nx*nl]);
       for (ix=0;ix<nx;ix++)
          for (it=0;it<nt;it++)
             for (il=0;il<nl;il++)
                err[il+it*nl+ix*nt*nl]=errc[il+ix*nl+it*nx*nl];    
       fprintf (stderr,"bi-directional smoothing done!\n");
       time2=time(NULL);
       tbds=time2-time1;
    }
    if (hbt>0)
    {
       fprintf(stderr,"doing horizontal backtracking!\n");
       time1=time(NULL);
       for (ix=0;ix<nx;ix++)
          for (it=0;it<nt;it++)
             for (il=0;il<nl;il++)
                errr[il+ix*nl+it*nx*nl]=err[il+it*nl+ix*nt*nl];    
       for (it=0;it<nt;it++)
          accumulate(-1, b, nl, nx, &errr[it*nx*nl], &errf[it*nx*nl]);
       time2=time(NULL);
       tac=time2-time1;
       fprintf (stderr,"accumulation done!\n");
       time1=time(NULL);
       for (it=0;it<nt;it++)
          backtrack(1, b, -ntlag, nl, nx, &errf[it*nx*nl], &errr[it*nx*nl], &ut[it*nx]);
       time2=time(NULL);
       tbt=time2-time1;
       for (ix=0;ix<nx;ix++)
          for (it=0;it<nt;it++)
             {
                u[it+ix*nt]=ut[ix+it*nx];
             }
       for (ix=0;ix<nx;ix++)
          for (it=0;it<nt;it++)
             for (il=0;il<nl;il++)
                errc[il+it*nl+ix*nt*nl]=errf[il+ix*nl+it*nx*nl];    
    }
    else
    {
       time1=time(NULL);
       for (ix=0;ix<nx;ix++)
          accumulate(1, b, nl, nt, &err[ix*nt*(2*ntlag+1)], &errc[ix*nt*(2*ntlag+1)]);
       fprintf (stderr,"accumulation done!\n");
       time2=time(NULL);
       tac=time2-time1;
       time1=time(NULL);
       for (ix=0;ix<nx;ix++)
          backtrack(-1, b, -ntlag, nl, nt, &errc[ix*nt*(2*ntlag+1)], &err[ix*nt*(2*ntlag+1)], &u[ix*nt]);
       time2=time(NULL);
       tbt=time2-time1;
    }
    fprintf(stderr,"tgenerr=%ld s, t bi-directional smoothing = %ld s, t accumulation = %ld s, t backtracking = %ld s\n",terr,tbds,tac,tbt);
    ndim=2;
    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=ot;
    outfile.d[0]=dt;
    outfile.n[0]=nt;
    outfile.o[1]=ox;
    outfile.d[1]=dx;
    outfile.n[1]=nx;
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("out",&outfile))
       seperr("unable to output parameters for out\n");

    if( (nx*nt*4)!=srite("out",u,4*nx*nt) )
       seperr("trouble writing out zbtm\n");
    
    ndim=3;
    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=-ntlag*dt;
    outfile.d[0]=dt;
    outfile.n[0]=2*ntlag+1;
    outfile.o[1]=ot;
    outfile.d[1]=dt;
    outfile.n[1]=nt;
    outfile.o[2]=ox;
    outfile.d[2]=dx;
    outfile.n[2]=nx;
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("er",&outfile))
       seperr("unable to output parameters for er\n");

    if( (nx*nt*(2*ntlag+1)*4)!=srite("er",err,4*nx*nt*(2*ntlag+1)) )
       seperr("trouble writing out er\n");
    /*
    ndim=3;
    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=-ntlag*dt;
    outfile.d[0]=dt;
    outfile.n[0]=2*ntlag+1;
    outfile.o[1]=ot;
    outfile.d[1]=dt;
    outfile.n[1]=nt;
    outfile.o[2]=ox;
    outfile.d[2]=dx;
    outfile.n[2]=nx;
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("erc",&outfile))
       seperr("unable to output parameters for er\n");
    
    if( (nx*nt*(2*ntlag+1)*4)!=srite("erc",errc,4*nx*nt*(2*ntlag+1)) )
       seperr("trouble writing out er\n");
    */
    return 0;
}

void generr1(int nl, int ni, int nx, int w, float *dat, float *dat1, float *e)
{
   int i,j,il,iw,ix;
   float tmp1,tmp2;
   float pi=3.1415926;
   double sum1,sum2,xcorr;
   float coef;
   for (ix=0;ix<nx;ix++)
      for (i=0;i<ni;i++)
         for (il=0;il<nl;il++)
            e[il+nl*i+ix*nl*ni]=1.;
   for (ix=0;ix<nx;ix++)
   {
      #pragma omp parallel for private(i,il,iw,coef,tmp1,tmp2,xcorr,sum1,sum2) schedule(dynamic,8)
      for (i=w;i<ni-w;i++)
      {
         for (il=(1-nl)/2;il<(nl-1)/2;il++)
         {
            if ((i+il)>=w && (i+il)<(ni-w))
            { 
               xcorr=0;
               sum1=0;
               sum2=0;
               for (iw=0;iw<2*w+1;iw++)
               {
                  coef=cos(pi*((1.*iw)/w-1.)*0.5);
                  tmp1=dat[i+iw-w+ix*ni]*coef;
                  tmp2=dat1[i+il+iw-w+ix*ni]*coef;
                  xcorr+=tmp1*tmp2;
                  sum1+=tmp1*tmp1;
                  sum2+=tmp2*tmp2;
               }
               e[il+(nl-1)/2+nl*i+ix*ni*nl]=1.-xcorr/(sqrt(sum1*sum2)+1e-7);
            }    
         }
       }
    }
}
void generr(int nl, int ni, int w, float *dat, float *dat1, float *e)
{
   int i,j,il,iw;
   float tmp1,tmp2;
   float pi=3.1415926;
   double sum1,sum2,xcorr;
   float coef;
   for (i=0;i<ni;i++)
     for (il=0;il<nl;il++)
        e[il+nl*i]=1.;
     #pragma omp parallel for private(i,il,iw,coef,tmp1,tmp2,xcorr,sum1,sum2) schedule(dynamic,8)
   for (i=w;i<ni-w;i++)
   {
     //#pragma omp parallel for private(il,iw,coef,tmp1,tmp2,xcorr,sum1,sum2) schedule(dynamic,8)
     for (il=(1-nl)/2;il<(nl-1)/2;il++)
     {
        if ((i+il)>=w && (i+il)<(ni-w))
        {
           xcorr=0;
           sum1=0;
           sum2=0;
           for (iw=0;iw<2*w+1;iw++)
           {
              coef=cos(pi*((1.*iw)/w-1.)*0.5);
              tmp1=dat[i+iw-w]*coef;
              tmp2=dat1[i+il+iw-w]*coef;
              xcorr+=tmp1*tmp2;
              sum1+=tmp1*tmp1;
              sum2+=tmp2*tmp2;
              //if (coef!=0.)
              //   fprintf(stderr,"coef=%f\n",coef);
           }
           //if (xcorr!=0.)
           //   fprintf(stderr,"sqrt(sum1*sum2)=%f,xcorr=%f, i=%d,il=%d\n",sqrt(sum1*sum2),xcorr,i,il);
           e[il+(nl-1)/2+nl*i]=1.-xcorr/(sqrt(sum1*sum2)+1e-7);
        }    
     }
   }
}
