#include "stdlib.h"
#include "math.h"
#include "string.h"
#include <sep_pars_external.h>
#include <seplib.h>
#include <sep3dc.h>


int main(int argc, char** argv)
{
    int ndim;
    int   nt, n2, n3, n, ntr, ntrleft;
    float ot, o2, o3, o;
    float dt, d2, d3, d;
    int   it, itsft, i;
    int ncnt,maxcnt,itofst;
    int idx,nidx;
    float *data;
    float *tsft,*tr;
    char temp_char[256];
    sep3d outfile; 

    initpar(argc,argv);


    if (0==getch("ncnt","i", &ncnt)) ncnt=1000;

     if(0!=sep_get_number_data_axes("in",&ndim))
       seperr("unable to get dimension from src!\n");

    for(i=1;i<=ndim;i++)
    {
       if(0!=sep_get_data_axis_par("in",&i,&n,&o,&d,temp_char))
       seperr("unable to get parameters from src!\n");
       if(i==1)
       {
          nt=n;
          dt=d;
          ot=o;
       }
       else if(i==2)
       {
          n2=n;
          o2=o;
          d2=d;
       }
       else if(i==3)
       {
          n3=n;
          o3=o;
          d3=d;
       }
       else if(i>=4)
       {
          fprintf(stderr,"Error, only handle 3 dimentsional data!\n");
       }
    }
    if (ndim==2)
       ntr=n2;
    else if (ndim==3)
       ntr=n2*n3;
    tsft=(float*)malloc(sizeof(float)*ncnt);
    data=(float*)malloc(sizeof(float)*ncnt*nt);
    tr=(float*)malloc(sizeof(float)*nt);

    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=ot;
    outfile.d[0]=dt;
    outfile.n[0]=nt;
    outfile.o[1]=o2;
    outfile.d[1]=d2;
    outfile.n[1]=n2;
    if (ndim==3)
    {
       outfile.o[2]=o3;
       outfile.d[2]=d3;
       outfile.n[2]=n3;
    }
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("out",&outfile))
       seperr("unable to output parameters for out\n");
    
    ntrleft=ntr;
    idx=0;
    nidx=ncnt/ntr;
    fprintf(stderr,"ntr=%d,ncnt=%d,nt=%d\n",ntr,ncnt,nt);
    while(ntrleft>0)
    {
	if (ntrleft>ncnt)
           maxcnt=ncnt;
        else
          maxcnt=ntrleft; 
  
        if ((maxcnt*4)!=sreed("tsft",tsft,maxcnt*4))
           seperr("Error read in tsft file \n");
        if ((maxcnt*nt*4)!=sreed("in",data,maxcnt*4*nt))
           seperr("Error read in data file o\n");
        for (i=0;i<maxcnt;i++)
        {
           for (it=0;it<nt;it++)
              tr[it]=0;
           itsft=tsft[i]/dt;
           //if (itsft!=0)
           //   fprintf(stderr,"itsft=%d for i=%d\n",itsft,i);
           for (it=0;it<nt-itsft;it++)
           { 
              tr[it]=data[it+itsft+i*nt];
           }           
           for (it=0;it<nt;it++)
           { 
              data[it+i*nt]=tr[it];
           }           
        }
        if( (nt*maxcnt*4)!=srite("out",data,4*nt*maxcnt) )
        seperr("trouble writing out data\n");
        ntrleft-=maxcnt;
        idx++;
        if ((idx%5)==0)
           fprintf(stderr,"finished %d of total %d \n",idx,nidx);
    }
    
    return 0;
}
