#include "stdlib.h"
#include "math.h"
#include "string.h"
#include <seplib.h>
#include <sep3dc.h>


#define xmax(a,b) ((a)>(b)?(a):(b))
#define xmin(a,b) ((a)<(b)?(a):(b))
#define xbound(a1,a,a2) (xmin( (xmax((a1),(a))),(a2) ))
int main(int argc, char** argv)
{
    int ndim,n,flag;
    float o,d;
    char temp_char[256];
    int   n1, n2, n3;
    float o1, o2, o3;
    float d1, d2, d3;
    int   i1, i2, i3, i, ibeg, iend;
    float *mv1in, *mv2in, *outnum, *outimag, *p1denom, *p2denom;
    float p1zt, p1xt, p2zt, p2xt;
    sep3d outfile; 
    initpar(argc,argv);
    // read t,x,y from source file
   
    if(0!=sep_get_number_data_axes("in",&ndim))
       seperr("unable to get dimension from src!\n");
    
    for(i=1;i<=ndim;i++)
    {
       if(0!=sep_get_data_axis_par("in",&i,&n,&o,&d,temp_char))
       seperr("unable to get parameters from src!\n");
       if(i==1)
       {
          n1=n;
          d1=d;
          o1=o;
       }
       else if(i==2)
       {
          n2=n;
          d2=d;
          o2=o;
       }
       else if(i==3)
       {
          n3=n;
          d3=d;
          o3=o;
       }
    }

    fprintf(stderr,"n1=%d, n2=%d, n3=%d\n",n1,n2,n3);
    // allocate memories

    mv1in=(float*)malloc(n1*n2*n3*sizeof(float));
    mv2in=(float*)malloc(n1*n2*n3*sizeof(float));
    outnum=(float*)malloc(n1*n2*n3*sizeof(float));
    outimag=(float*)malloc(n1*n2*n3*sizeof(float));

    if ((n1*n2*n3*4)!=sreed("in",mv1in,n1*n2*n3*4))
       seperr("Error read in mv1 from stdin\n");

    if ((n1*n2*n3*4)!=sreed("mv2",mv2in,n1*n2*n3*4))
       seperr("Error read in mv2 from mv2\n");

    for (i3=0;i3<n3;i3++)
       for (i2=0;i2<n2;i2++)
          for (i1=0;i1<n1;i1++)
          {
	      outnum[i1+i2*n1+i3*n1*n2]=0; 
	      outimag[i1+i2*n1+i3*n1*n2]=0; 
          }


    for (i3=2;i3<n3-2;i3++)
       for (i2=2;i2<n2-2;i2++)
          for (i1=2;i1<n1-2;i1++)
          {
             //p1zt = (mv1in[i1+0+i2*n1+i3*n1*n2]-mv1in[i1-1+i2*n1+i3*n1*n2])/(mv1in[i1+i2*n1+(i3+0)*n1*n2]-mv1in[i1+i2*n1+(i3-1)*n1*n2]+1e-14);
             //p1xt = (mv1in[i1+(i2+0)*n1+i3*n1*n2]-mv1in[i1+(i2-1)*n1+i3*n1*n2])/(mv1in[i1+i2*n1+(i3+0)*n1*n2]-mv1in[i1+i2*n1+(i3-1)*n1*n2]+1e-14);
             //p2zt = (mv2in[i1+0+i2*n1+i3*n1*n2]-mv2in[i1-1+i2*n1+i3*n1*n2])/(mv2in[i1+i2*n1+(i3+0)*n1*n2]-mv2in[i1+i2*n1+(i3-1)*n1*n2]+1e-14);
             //p2xt = (mv2in[i1+(i2+0)*n1+i3*n1*n2]-mv2in[i1+(i2-1)*n1+i3*n1*n2])/(mv2in[i1+i2*n1+(i3+0)*n1*n2]-mv2in[i1+i2*n1+(i3-1)*n1*n2]+1e-14);
             p1zt = (mv1in[i1+1+i2*n1+i3*n1*n2]-mv1in[i1-1+i2*n1+i3*n1*n2])/(mv1in[i1+i2*n1+(i3+1)*n1*n2]-mv1in[i1+i2*n1+(i3-1)*n1*n2]+1e-14);
             p1xt = (mv1in[i1+(i2+1)*n1+i3*n1*n2]-mv1in[i1+(i2-1)*n1+i3*n1*n2])/(mv1in[i1+i2*n1+(i3+1)*n1*n2]-mv1in[i1+i2*n1+(i3-1)*n1*n2]+1e-14);
             p2zt = (mv2in[i1+1+i2*n1+i3*n1*n2]-mv2in[i1-1+i2*n1+i3*n1*n2])/(mv2in[i1+i2*n1+(i3+1)*n1*n2]-mv2in[i1+i2*n1+(i3-1)*n1*n2]+1e-14);
             p2xt = (mv2in[i1+(i2+1)*n1+i3*n1*n2]-mv2in[i1+(i2-1)*n1+i3*n1*n2])/(mv2in[i1+i2*n1+(i3+1)*n1*n2]-mv2in[i1+i2*n1+(i3-1)*n1*n2]+1e-14);
             //p1zt = (mv1in[i1+2+i2*n1+i3*n1*n2]+2.*mv1in[i1+1+i2*n1+i3*n1*n2]-2.*mv1in[i1-1+i2*n1+i3*n1*n2]-mv1in[i1-2+i2*n1+i3*n1*n2])/(mv1in[i1+i2*n1+(i3+2)*n1*n2]+2.*mv1in[i1+i2*n1+(i3+1)*n1*n2]-2.*mv1in[i1+i2*n1+(i3-1)*n1*n2]-mv1in[i1+i2*n1+(i3-2)*n1*n2]+1e-14);
             //p1xt = (mv1in[i1+(i2+2)*n1+i3*n1*n2]+2.*mv1in[i1+(i2+1)*n1+i3*n1*n2]-mv1in[i1+(i2-1)*n1+i3*n1*n2]-mv1in[i1+(i2-2)*n1+i3*n1*n2])/(mv1in[i1+i2*n1+(i3+2)*n1*n2]+2.*mv1in[i1+i2*n1+(i3+1)*n1*n2]-2.*mv1in[i1+i2*n1+(i3-1)*n1*n2]-mv1in[i1+i2*n1+(i3-2)*n1*n2]+1e-14);
             //p2zt = (mv2in[i1+2+i2*n1+i3*n1*n2]+2.*mv2in[i1+1+i2*n1+i3*n1*n2]-2.*mv2in[i1-1+i2*n1+i3*n1*n2]-mv2in[i1-2+i2*n1+i3*n1*n2])/(mv2in[i1+i2*n1+(i3+2)*n1*n2]+2.*mv2in[i1+i2*n1+(i3+1)*n1*n2]-2.*mv2in[i1+i2*n1+(i3-1)*n1*n2]-mv2in[i1+i2*n1+(i3-2)*n1*n2]+1e-14);
             //p2xt = (mv2in[i1+(i2+2)*n1+i3*n1*n2]+2.*mv2in[i1+(i2+1)*n1+i3*n1*n2]-2.*mv2in[i1+(i2-1)*n1+i3*n1*n2]-mv2in[i1+(i2-2)*n1+i3*n1*n2])/(mv2in[i1+i2*n1+(i3+2)*n1*n2]+2.*mv2in[i1+i2*n1+(i3+1)*n1*n2]-2.*mv2in[i1+i2*n1+(i3-1)*n1*n2]-mv2in[i1+i2*n1+(i3-2)*n1*n2]+1e-14);
	     outnum[i1+i2*n1+i3*n1*n2]=(p1zt*p2zt+p1xt*p2xt)/(sqrt(p1zt*p1zt+p1xt*p1xt)*sqrt(p2zt*p2zt+p2xt*p2xt)+1e-14); 
             p1zt = (mv1in[i1+1+i2*n1+i3*n1*n2]-mv1in[i1-1+i2*n1+i3*n1*n2]);
             p1xt = (mv1in[i1+(i2+1)*n1+i3*n1*n2]-mv1in[i1+(i2-1)*n1+i3*n1*n2]);
             p2zt = (mv2in[i1+1+i2*n1+i3*n1*n2]-mv2in[i1-1+i2*n1+i3*n1*n2]);
             p2xt = (mv2in[i1+(i2+1)*n1+i3*n1*n2]-mv2in[i1+(i2-1)*n1+i3*n1*n2]);
	     outimag[i1+i2*n1+i3*n1*n2]=(p1zt*p2zt+p1xt*p2xt);
	  }
     

    ndim=3;
    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=o1;
    outfile.d[0]=d1;
    outfile.n[0]=n1;
    outfile.o[1]=o2;
    outfile.d[1]=d2;
    outfile.n[1]=n2;
    outfile.o[2]=o3;
    outfile.d[2]=d3;
    outfile.n[2]=n3;
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("out",&outfile))
       seperr("unable to output parameters for out\n");

    if( (n1*n2*n3*4)!=srite("out",outnum,4*n1*n2*n3) )
       seperr("trouble writing stdout \n");


    ndim=3;
    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=o1;
    outfile.d[0]=d1;
    outfile.n[0]=n1;
    outfile.o[1]=o2;
    outfile.d[1]=d2;
    outfile.n[1]=n2;
    outfile.o[2]=o3;
    outfile.d[2]=d3;
    outfile.n[2]=n3;
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("imag",&outfile))
       seperr("unable to output parameters for out\n");

    if( (n1*n2*n3*4)!=srite("imag",outimag,4*n1*n2*n3) )
       seperr("trouble writing stdout \n");

    return 0;
}
