#include "stdlib.h"
#include "math.h"
#include "string.h"
#include <seplib.h>
#include <sep3dc.h>


#define xmax(a,b) ((a)>(b)?(a):(b))
#define xmin(a,b) ((a)<(b)?(a):(b))
#define xbound(a1,a,a2) (xmin( (xmax((a1),(a))),(a2) ))
int main(int argc, char** argv)
{
    int ndim,n,flag;
    float o,d;
    char temp_char[256];
    int   n1, n2;
    float o1, o2;
    float d1, d2;
    int   i1, i2, i, ibeg, iend ;
    float vsalt, v0;
    float *velin;
    sep3d outfile; 
    initpar(argc,argv);
    // read t,x,y from source file
   
    if(0!=sep_get_number_data_axes("in",&ndim))
       seperr("unable to get dimension from src!\n");
    
    for(i=1;i<=ndim;i++)
    {
       if(0!=sep_get_data_axis_par("in",&i,&n,&o,&d,temp_char))
       seperr("unable to get parameters from src!\n");
       if(i==1)
       {
          n1=n;
          d1=d;
          o1=o;
       }
       else if(i==2)
       {
          n2=n;
          d2=d;
          o2=o;
       }
    }

    fprintf(stderr,"n1=%d, n2=%d\n",n1,n2);
    // readin other parameters
    if (0==getch("vsalt","f", &vsalt)) vsalt=4500;
    /*if (0==getch("k2","f", &slope2)) slope2=2;
    if (0==getch("flo","f", &flo)) flo=0;
    if (0==getch("ofst","f", &ofst)) ofst=0.1;
    if (0==getch("keep","f", &keep)) keep=1;
    if (0==getch("type","f", &type)) type=1;
    if (0==getch("halftaperwidth","i", &halftaperwidth)) halftaperwidth=5;

    fprintf(stderr,"n1=%d\n",n1);
    if (ofst<0) ofst=-ofst;
    if (slope<0) slope=-slope;
    if (slope2<0) slope2=-slope2;
    */
    // allocate memories

    velin=(float*)malloc(n1*n2*sizeof(float)*2);

    if ((n1*n2*4)!=sreed("in",velin,n1*n2*4))
       seperr("Error read in fk domain data from stdin\n");

    fprintf(stderr,"after sreed, n1=%d\n",n1);
    //change anomaly 1
    for (i2=0;i2<n2;i2++)
    {
          v0=vsalt;
          flag=0;
          for (i1=0;i1<n1;i1++)
          { 
             i=i1+i2*n1;
             if (flag==0 && velin[i]>vsalt)
             {
                flag=1;
                v0=velin[i];
             }
             if (flag==1)
                velin[i]=v0;
                
	  }
    }


    ndim=2;
    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=o1;
    outfile.d[0]=d1;
    outfile.n[0]=n1;
    outfile.o[1]=o2;
    outfile.d[1]=d2;
    outfile.n[1]=n2;
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("out",&outfile))
       seperr("unable to output parameters for out\n");

    if( (n1*n2*4)!=srite("out",velin,4*n1*n2) )
       seperr("trouble writing stdout \n");

    return 0;
}
