#include "stdlib.h"
#include "math.h"
#include "string.h"
#include <seplib.h>
#include <sep3dc.h>


#define xmax(a,b) ((a)>(b)?(a):(b))
#define xmin(a,b) ((a)<(b)?(a):(b))
#define xbound(a1,a,a2) (xmin( (xmax((a1),(a))),(a2) ))
int main(int argc, char** argv)
{
    int ndim,n,flag;
    float o,d;
    char temp_char[256];
    int   n1, n2;
    float o1, o2;
    float d1, d2;
    int   i1, i2, i, nsed ;
    float *velin, *velout, *saltdep;
    float vsalt, vsedmax;
    sep3d outfile; 
    initpar(argc,argv);
    // read t,x,y from source file
   
    if(0!=sep_get_number_data_axes("in",&ndim))
       seperr("unable to get dimension from src!\n");
    
    for(i=1;i<=ndim;i++)
    {
       if(0!=sep_get_data_axis_par("in",&i,&n,&o,&d,temp_char))
       seperr("unable to get parameters from src!\n");
       if(i==1)
       {
          n1=n;
          d1=d;
          o1=o;
       }
       else if(i==2)
       {
          n2=n;
          d2=d;
          o2=o;
       }
    }

    if (0==getch("vsalt","f", &vsalt)) vsalt=4500;
    fprintf(stderr,"n1=%d, n2=%d\n",n1,n2);
    // allocate memories

    velin=(float*)malloc(n1*n2*sizeof(float));
    velout=(float*)malloc(n1*n2*sizeof(float));

    if ((n1*n2*4)!=sreed("in",velin,n1*n2*4))
       seperr("Error read in fk domain data from stdin\n");

    fprintf(stderr,"after sreed, n1=%d\n",n1);
    for (i=0;i<n1*n2;i++) 
       velout[i]=velin[i]; 
    //change anomaly 1
    for (i=0;i<n1*n2;i++)
    {
       if (velout[i]>vsalt)
          velout[i]=vsalt;
       else
          velout[i]=0;
    }
    ndim=2;
    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=o1;
    outfile.d[0]=d1;
    outfile.n[0]=n1;
    outfile.o[1]=o2;
    outfile.d[1]=d2;
    outfile.n[1]=n2;
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("out",&outfile))
       seperr("unable to output parameters for out\n");

    if( (n1*n2*4)!=srite("out",velout,4*n1*n2) )
       seperr("trouble writing stdout \n");

    return 0;
}
