program Xsrcfilt
  use sep
  use billgen
  
  implicit none
  include 'fftw3.f'

  integer, dimension (:), allocatable     :: ntx, nxw, nx  
  real,    dimension (:), allocatable     :: otx, dtx, oxw, dxw, ox, dx 
  integer                                 :: ndim,nw,nt,i,iw,it,jt,nto,iw0
  real                                    :: ow,dw,ot,dt
  real                                    :: w,theta
  double precision                        :: pi
  integer                                 :: nxhelix,forward,wht_type
  real, dimension (:,:), allocatable      :: ddtx
  complex, dimension (:,:), allocatable   :: ddxw
  real , dimension (:), allocatable       :: ftt
  complex, dimension (:), allocatable     :: ftw
  integer*8                               :: plan,plani 
 

  call initpar()
  call sep_init ()

  ndim = sep_dimension ()
  !determine dimensional parameters
  allocate ( ntx(ndim), dtx(ndim), otx(ndim), nxw(ndim), dxw(ndim), oxw(ndim), nx(ndim-1), dx(ndim-1), ox(ndim-1) )
  call from_param("theta",theta,0.)
  call from_param("wht_type",wht_type,0)
  
  call get_history(ntx,otx,dtx)
  pi=3.14159265
  theta = theta*pi/180.
  nx=ntx(2:ndim)
  dx=dtx(2:ndim)
  ox=otx(2:ndim)
  nt=ntx(1)
  dt=dtx(1)
  ot=otx(1)
  nw=nt/2+1
  dw=1./(nt*dt)
  ow=0.
  write(0,*)"input               ndim: ",ndim
  write(0,*)"input               nin: ",ntx
  
  nxhelix = product(nx)
 
  allocate ( ddtx(nt,nxhelix), ftt(nt), ftw(nw) )
  
  call sfftw_plan_dft_r2c_1d(plan,nt,ftt,ftw,FFTW_ESTIMATE)
  call sfftw_plan_dft_c2r_1d(plani,nt,ftw,ftt,FFTW_ESTIMATE)
     
  call sreed("in",ddtx,nt*nxhelix*4)
 
  do i=1,nxhelix
     ftt=ddtx(:,i)
     call sfftw_execute(plan)
     
     ftw(1) = ftw(1) *cexp(cmplx(cos(theta),sin(theta)))
     do iw=2,nw
        ftw(iw) = ftw(iw) *cexp(cmplx(cos(theta),sin(theta)))
        w=ow+(iw-1)*dw
        if (wht_type.eq.1) then 
           ftw(iw)= ftw(iw)*sqrt(w)
        elseif (wht_type.eq.2) then 
           ftw(iw)= ftw(iw)*w
        elseif (wht_type.eq.3) then 
           ftw(iw)= ftw(iw)/sqrt(w)
        elseif (wht_type.eq.4) then 
           ftw(iw)= ftw(iw)/w
        end if
     end do   
     call sfftw_execute(plani)
     ddtx(:,i)=ftt*(1./nt)
  end do  
  call put_history(ntx,otx,dtx,4)
  call srite("out",ddtx,nt*nxhelix*4)
end program Xsrcfilt
